Program ZModem;

Uses CRT, COM;

Const
  Esc = #27;
  CR = #13;
  LF = #10;
  TAB = #9;

Var
  ComNo : Byte;
  Key, Chr : Char;

Begin
  ClrScr;
  WriteLn ('-= Simple ZModem-cable terminal program =-');
  Write ('Please choose a COM port to use (1..4): ');
  Repeat
    Key := ReadKey;
    Case Key of
      '1'..'4': Begin ComNo := Ord(Key)-Ord('0'); Break End;
      Esc : Begin WriteLn; Exit End
    End;
  Until False;
  If ComBasePort[ComNo] = 0 then Begin
    WriteLn (#13#10'COM',Key,' is not avaible.');
    Exit
  End;
  WriteLn (#13#10'Type anything. ESC - exit.');

  OpenCom (ComNo, B_9600, Bits_8+Stops_2+Parity_No, 2048);
  While ReceivedFromCom (ComNo) > 0 do ReadCom (ComNo, Chr);    { For debug }

  While Key <> Esc do Begin
    If Keypressed then Begin
      Key := ReadKey;
      WriteCom (ComNo, Key)
    End;
    If ReceivedFromCom (ComNo) > 0 then Begin
      ReadCom (ComNo, Chr);
      If Chr = Esc then Begin
        WriteLn ('Remote machine disconnected.');
        Continue
      End;
      Write (Chr);
      If Chr = CR then Write (LF)
    End
  End;

  CloseCom (ComNo)
End.
